VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3990
   ClientLeft      =   1845
   ClientTop       =   2010
   ClientWidth     =   5070
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   266
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   338
   Begin VB.PictureBox ToPict 
      Height          =   1695
      Left            =   3960
      ScaleHeight     =   109
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   54
      TabIndex        =   2
      Top             =   120
      Width           =   870
   End
   Begin VB.CommandButton CmdRotate 
      Caption         =   "Rotate"
      Default         =   -1  'True
      Height          =   495
      Left            =   1440
      TabIndex        =   1
      Top             =   1200
      Width           =   1215
   End
   Begin VB.PictureBox FromPict 
      AutoSize        =   -1  'True
      Height          =   990
      Left            =   120
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   62
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   248
      TabIndex        =   0
      Top             =   120
      Width           =   3780
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' *********************************************
' Rotate fr_pic 90 degrees and place the result
' in to_pic. Both PictureBoxes should have
' AutoRedraw = True.
' *********************************************
Public Sub RotatePicture(fr_pic As PictureBox, to_pic As PictureBox)
Dim fr_pixels() As RGBTriplet
Dim to_pixels() As RGBTriplet
Dim bits_per_pixel As Integer
Dim fr_wid As Long
Dim fr_hgt As Long
Dim to_wid As Long
Dim to_hgt As Long
Dim X As Integer
Dim Y As Integer

    ' Get the picture's image.
    GetBitmapPixels fr_pic, fr_pixels, bits_per_pixel

    ' Get the picture's size.
    fr_wid = UBound(fr_pixels, 1) + 1
    fr_hgt = UBound(fr_pixels, 2) + 1
    to_wid = fr_hgt
    to_hgt = fr_wid

    ' Size the output picture to fit.
    to_pic.Width = to_pic.Parent.ScaleX(fr_hgt, vbPixels, to_pic.Parent.ScaleMode) + _
        to_pic.Width - to_pic.ScaleWidth
    to_pic.Height = to_pic.Parent.ScaleY(fr_wid, vbPixels, to_pic.Parent.ScaleMode) + _
        to_pic.Height - to_pic.ScaleHeight

    ' Copy the pixels rotated 90 degrees.
    ReDim to_pixels(0 To to_wid - 1, 0 To to_hgt - 1)
    For X = 0 To fr_wid - 1
        For Y = 0 To fr_hgt - 1
            to_pixels(to_wid - Y - 1, X) = fr_pixels(X, Y)
        Next Y
    Next X

    ' Display the result.
    SetBitmapPixels to_pic, bits_per_pixel, to_pixels

    ' Make the image permanent.
    to_pic.Refresh
    to_pic.Picture = to_pic.Image
End Sub

Private Sub CmdRotate_Click()
    RotatePicture FromPict, ToPict
End Sub


